#include <stdio.h>
#include <math.h>

#define OPT_EXP 1
#define OPT_AFT 2
#define OPT_NOF 4

FILE * f = stdin;
FILE * fout = stdout;
char fichier[60] = "stdin";

int opt;
unsigned char buf [ 2048 ];
int sbuf;
unsigned char modele;
int mesure = 4;

#include "motcle.h"

char * fct1();
char * fct2();
char * fct3();
char * fct4();

int lect ( nb )
int nb;
{
	int ret;

	ret = fread ( buf, 1, nb, f );
	if ( ret == -1 )
	{
		perror ( "fread" );
		exit ( 1 );
	}
	if ( ret != nb )
	{
		printf ( "\nErreur FREAD %d -> %d\n", nb, ret );
		fprintf ( fout, "\nErreur FREAD %d -> %d\n", nb, ret );
	}

	sbuf = ret;
	return ret;
}

int dump ( )
{
	int i = 0;

	while ( i < sbuf )
	{
		if ( i % 16 == 0 )
			fprintf ( fout, "\t%04X:", i );
		fprintf ( fout, " %02X", buf[i] );
		i++;
		if ( i % 16 == 0 )
			fprintf ( fout, "\n" );
	}
	if ( i % 16 != 0 )
		fprintf ( fout, "\n" );
	return 0;
}

int t;
int tmesure;
int ttemps;
int t1;
int nt1;
double ct1;
int canal;
double tempo;
double newtempo;

char * lig ( m )
int m;
{
	static char strt[80];

	while ( t >= 24 )
	{
		t -= 24;
		ttemps++;
	}

	while ( ttemps > mesure )
	{
		ttemps -= mesure;
		tmesure++;
	}

	if ( canal == 0 )
		sprintf ( strt, "%03d.%d.%02d.%03d --- %s",
			tmesure,			/* mesure */
			ttemps,			/* temps */
			t,					/* temps / 24 */
			t1,				/* msec */
			mot[m] );
	else
		sprintf ( strt, "%03d.%d.%02d.%03d C%02d %s",
			tmesure,			/* mesure */
			ttemps,			/* temps */
			t,					/* temps / 24 */
			t1,				/* msec */
			canal, mot[m] );
	return strt;
}

int main ( argc, argv )
int argc;
char * argv[];
{
	int i;
	char *p;
	int c,c1,c2;

	opt = 0;

	for ( i = 1; i < argc; i++ )
	{
		if ( argv[i][0] == '-' )
		{
			for ( p = argv[i] + 1; *p; p++ )
			{
				switch ( tolower(*p) )
				{
					case 'e': opt |= OPT_EXP; break;
					case 'o': opt |= OPT_NOF; break;
					case 'a': opt |= OPT_AFT; break;
					case '2': mesure = 2; break;
					case '3': mesure = 3; break;
					case '4': mesure = 4; break;
					case '5': mesure = 5; break;
					case '6': mesure = 6; break;
					case '7': mesure = 7; break;
					case '8': mesure = 8; break;
					case '9': mesure = 9; break;
					default:
						fprintf ( stderr, "syntaxe: %s [-eoa2..9] fichier.evt\n", argv[0] );
						fprintf ( stderr, "\t-e  sans Expression Pedal\n" );
						fprintf ( stderr, "\t-o  sans Note Off\n" );
						fprintf ( stderr, "\t-a  sans After Touch\n" );
						fprintf ( stderr, "\t-N  mesure a N temps (2..9)\n" );
						exit ( 2 );
				}
			}
		}
		else
		{
			strcpy ( fichier, argv[i] );
			f = fopen ( fichier, "rb" );
			if ( f == NULL )
			{
				perror ( fichier );
				exit ( 1 );
			}
		}
	}

	for ( p = fichier; ( *p != '\0' ) && ( *p != '.' ); p++ )
		;
	*p = '\0';
	strcat ( fichier, ".gen" );

	printf ( "Generation du fichier %s...\n", fichier );
	fout = fopen ( fichier, "w" );
	if ( fout == NULL )
	{
		perror ( fichier );
		exit ( 1 );
	}

	fprintf ( fout, "FICHIER: %s\n", fichier );
	fprintf ( fout, "ENTETE:\n" );
	lect ( 7 );
	dump ( );
	lect ( 16 );
	dump ( );
	lect ( 16 );
	dump ( );
	lect ( 256 - 7 - 16 - 16 );
	fprintf ( fout, "\n" );

	t = 0;				/* tick horloge MIDI (24 ticks par temps) */
	ttemps = 1;			/* position courante: temps dans la mesure */
	tmesure = 1;		/* position courante: mesure dans le morceau */
	t1 = 0;				/* top horloge MDR (1000 top par secondes) */
	tempo = 100.0;		/* tempo du morceau */
	ct1 = 2500.0 / tempo;	/* nombre de tops entre deux ticks */
	nt1 = 0;				/* nombre de calcul de tempo */

	if ( mesure != 4 )
		fprintf ( fout, "%s %d\n", lig(18), mesure );

	while ( ( c = getc ( f ) ) != EOF )
	{
		canal = 0;
		switch ( c )
		{
			case 0xf3: /* temps 1 octet */
				c = getc ( f );
				t1 += c;
				break;

			case 0xf4: /* temps 2 octets */
				c1 = getc ( f );
				c2 = getc ( f );
				t1 += (int)c1 + 128 * (int)c2;
				break;

			case 0xfe:
				c = getc ( f );
				switch ( c )
				{
					case 0x78:	/* tick MIDI */
						if ( t1 == 0 )
							break;
						t += 1;
						if ( fabs ( ct1 - t1 ) >= 2.0 )
						{
							ct1 = t1;
							t1 = 0;
							nt1 = 0;
						}
						else
						{
							ct1 = ( ct1 * 9.0 + t1 ) / 10.0;
							t1 = 0;
							if ( nt1 < 10 )
							{
								nt1 += 1;
							}
							else
							{
								newtempo = 2500.0 / ct1;
								if ( fabs ( newtempo - tempo ) > 1.0 )
								{
									tempo = newtempo;
									fprintf ( fout, "%s %3d\n",
										lig(17), (int)(0.5+tempo) );
								}
							}
						}
						break;

					case 0x7a:	/* Start */
						fprintf ( fout, "%s\n", lig(16) );
						t = 0;
						ttemps = 1;
						tmesure = 1;
						t1 = 0;
						nt1 = 0;
						fprintf ( fout, "%s\n", lig(1) );
						break;

					case 0x7c:	/* Stop */
						fprintf ( fout, "%s\n", lig(2) );
						break;

					default:
						fprintf ( fout, "%s 0xFE 0x%02X\n", lig(20), c );
						break;
				}
				break;

			case 0xf0:			/* message exclusif ... */
				sbuf = 0;
				while ( c != 0xf7 )
				{
					buf [ sbuf++ ] = c;
					c = getc ( f );
				}
				buf [ sbuf++ ] = c;
				f0 ( buf, sbuf );
				break;

			case 0xf1: /* DEBUT */
				c = getc ( f );
				fprintf ( fout, "%s 0x%02X\n", lig(3), c );
				break;

			case 0xf2: /* FIN */
				fprintf ( fout, "%s\n", lig(4) );
				break;

			case 0xf6: /* NOP */
				fprintf ( fout, "%s\n", lig(12) );
				exit ( 0 );
				break;

			case 0xf5: case 0xf7: case 0xf8: case 0xf9:
			case 0xfa: case 0xfb: case 0xfc: case 0xfd: case 0xff:
				fprintf ( fout, "%s 0x%02X\n", lig(0), c );
				break;

			default:
				canal = ( c & 0x0f ) + 1;
				switch ( c & 0xf0 )
				{

					case 0xb0:
						c = getc ( f );
						c1 = getc ( f );
						switch ( c )
						{
							case 0x04:
								if ( ! ( opt & OPT_EXP ) )
									fprintf ( fout, "%s %3d\n", lig(13), c1 );
								break;
							case 0x0B:
								if ( ! ( opt & OPT_EXP ) )
									fprintf ( fout, "%s %3d\n", lig(5), c1 );
								break;
							case 0x40:
								fprintf ( fout, "%s %3d\n", lig(6), c1 );
								break;
							case 0x7B:
								if ( ! ( opt & OPT_NOF ) )
									fprintf ( fout, "%s %3d\n", lig(7), c1 );
								break;
							default:
								fprintf ( fout, "%s 0xB0 0x%02X 0x%02X\n", lig(21), c, c1 );
								break;
						}
						break;

					case 0xc0:
						c = getc ( f );
						fprintf ( fout, "%s %3d\n", lig(8), c + 1 );
						break;

					case 0xe0:
						c = getc ( f );
						c1 = getc ( f );
						fprintf ( fout, "%s 0xE0 0x%02X 0x%02X\n", lig(21), c, c1 );
						break;

					case 0x80:
						c = getc ( f );
						c1 = getc ( f );
						if ( ! ( opt & OPT_NOF ) )
							fprintf ( fout, "%s %3d %3d\n", lig(9), c, c1 );
						break;

					case 0x90:
						c = getc ( f );
						c1 = getc ( f );
						if ( c1 != 0 )
							fprintf ( fout, "%s  %3d %3d\n", lig(10), c, c1 );
						else
							if ( ! ( opt & OPT_NOF ) )
								fprintf ( fout, "%s %3d %3d\n", lig(14), c, c1 );
						break;

					case 0xd0:
						c = getc ( f );
						if ( ! ( opt & OPT_AFT ) )
							fprintf ( fout, "%s %3d\n", lig(11), c );
						break;

					default:
						fprintf ( fout, "%s 0x%02X\n", lig(0), c );
						break;
				}
		}
	}

	fclose ( f );
	fclose ( fout );
	return 0;
}

int f0 ( pt, lg )
char * pt;
int lg;
{

	int i;

	for ( i = 0; i < sizeof(tab_f0)/sizeof(tab_f0[0]); i++ )
	{
		if ( memcmp ( tab_f0[i].mes, pt, tab_f0[i].nbc ) == 0 )
		{
			fprintf ( fout, "%s %s", lig(15), tab_f0[i].lib );
			fprintf ( fout, "%s",
				tab_f0[i].fct == 1 ? fct1 ( tab_f0[i].lib, pt, lg ) :
				tab_f0[i].fct == 2 ? fct2 ( tab_f0[i].lib, pt, lg ) :
				tab_f0[i].fct == 3 ? fct3 ( tab_f0[i].lib, pt, lg ) :
				tab_f0[i].fct == 4 ? fct4 ( tab_f0[i].lib, pt, lg ) : "" );
			fprintf ( fout, "\n" );
			break;
		}
	}
	return 0;
}

char * fct1 ( lib, pt, lg )
char * lib;
char * pt;
int lg;
{
	FILE * f;
	static n = 1;
	char fexcl[40];

	fprintf ( fout, ":\n" );
	dump ();
	sprintf ( fexcl, "excl_%03d.dmp", n++ );
	printf ( "%s : message exclusif MIDI %s\n",
		fexcl, lib );
	f = fopen ( fexcl, "wb" );
	if ( f != NULL )
	{
		fwrite ( pt, lg, 1, f );
		fclose ( f );
	}
	return "";
}

char * fct2 ( lib, pt, lg )
char * lib;
char * pt;
int lg;
{
	static char tpo[10];
	sprintf ( tpo, "%3d", pt[6] + 256 * pt[7] );
	return tpo;
}

char * fct3 ( lib, pt, lg )
char * lib;
char * pt;
int lg;
{
	static char sw[40];
	sprintf ( sw, "code=0x%02X data=0x%02X", pt[5], pt[6] );
	return sw;
}

char * fct4 ( lib, pt, lg )
char * lib;
char * pt;
int lg;
{
	static char bs[20];
	sprintf ( bs, "%d/%d", pt[5], pt[6] );
	return bs;
}

