/*
	File: BBB.C

	Make a listing of the registrations saved in a .B00 file or in a
	"current registration" record of a .EVT file

	-o option: make a .GEN file (ASCII EVT file) with drum track expanded

	-p option: used initialy to build the pattern.dat file, don't use it
*/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "b00.h"

int opt;	/* option flags passed as arguments on command line */

int main ( argc, argv )
int argc;
char * argv[];
{
	int i;
	char *p;

	opt = 0;

	for ( i = 1; i < argc; i++ )	/* for each argument on command line */
	{
		if ( argv[i][0] == '-' )	/* is it an option or a file ? */
		{
			for ( p = argv[i] + 1; *p; p++ )	/* read all the option letters */
			{
				switch ( tolower(*p) )
				{
					case 'a': opt |= OPT_ALL  ; break;
					case 'd': opt |= OPT_DEBUG; break;
					case 'f': opt |= OPT_FLU  ; break;
					case 's': opt |= OPT_SECT ; break;
					case 'v': opt |= OPT_VOICE; break;
					case 'x': opt |= OPT_XX   ; break;
					case 'y': opt |= OPT_YY   ; break;
					case '4': opt |= OPT_USER4; break;
					case '6': opt |= OPT_REG16; break;
					case '8': opt |= OPT_REG8 ; break;
					case 'o': opt |= OPT_OUT ; break;
					case 'p': opt |= OPT_PAT ; break;
					default:
						fprintf ( stderr, "syntax: %s [-adrvxy48soc] [b00_file]\n", argv[0] );
						fprintf ( stderr, "\t-a  display all settings\n" );
						fprintf ( stderr, "\t-d  debug mode\n" );
						fprintf ( stderr, "\t-f  dump of User Flutes\n" );
						fprintf ( stderr, "\t-s  dump of sections\n" );
						fprintf ( stderr, "\t-v  dump of USER VOICEs\n" );
						fprintf ( stderr, "\t-x  dump of all bytes\n" );
						fprintf ( stderr, "\t-y  dump of unknown bytes\n" );
						fprintf ( stderr, "\t-4  dump only 4 USER VOICEs\n" );
						fprintf ( stderr, "\t-6  dump 16 registrations\n" );
						fprintf ( stderr, "\t-8  dump only 8 registrations\n" );
						fprintf ( stderr, "\t-o  generate drum sequence file\n" );
						fprintf ( stderr, "\t-p  generate drum pattern data file\n" );

						exit ( 2 );
				}
			}
		}
		else
		{
			fic ( argv[i] );	/* run program on each file on command line */
		}
	}

	return 0;
}

