/*
	File PAT.C

	Dumping of Patterns and sequences, generating GEN file
*/

#include <stdio.h>
#include <mem.h>

#include "motcle.h"
#include "b00.h"

struct
{
	int t;	/* 0:vide 1:user 2:rythme 5:F+user 6:F+rythme */
	int n;	/* numero rythme user:67->67+39 rythme:0->66 */
} tabseq[4][120];

int sequence ( n, buf )
int n;
unsigned char * buf;
{
	int i;

	i = 0;
	if ( buf [ i ] != 0xff )
	{
		printf ( "\nSEQUENCE %d:\n", n+1 );
		printf ( "\t" );
		while ( buf [ i ] != 0xff )
		{
			if ( buf[i] & 0x80 )
			{
				if ( buf [ i + 1 ] & 0x01 )
				{
					tabseq[n][i/2].t = 5; /* user + fill */
					tabseq[n][i/2].n = 67 + ( buf[i] & 0x7f ) / 4 + 32;
				}
				else
				{
					tabseq[n][i/2].t = 1; /* user */
					tabseq[n][i/2].n = 67 + ( buf[i] & 0x7f );
				}
			}
			else
			{
				if ( buf[i] >= 67 )
				{
					if ( buf [ i + 1 ] & 0x01 )
					{
						tabseq[n][i/2].t = 5; /* user + fill */
						tabseq[n][i/2].n = 67 + ( buf[i] - 67 ) / 4 + 32;
					}
					else
					{
						tabseq[n][i/2].t = 1; /* user */
						tabseq[n][i/2].n = buf[i];
					}
				}
				else
				{
					tabseq[n][i/2].n = buf[i];
					if ( buf [ i + 1 ] & 0x01 )
						tabseq[n][i/2].t = 6; /* preset + fill */
					else
						tabseq[n][i/2].t = 2; /* preset */
				}
			}
			if ( tabseq[n][i/2].t & 0x04 )
				printf ( "F+%-8.8s", rythme ( tabseq[n][i/2].n ) );
			else
				printf ( "  %-8.8s", rythme ( tabseq[n][i/2].n ) );

			i += 2;
			if ( ( i % 8 ) == 0 )
				printf ( "\n\t" );
			else
				printf ( " " );

			if ( i >= 120*2 )
				break;
		}
		printf ( "\n" );
	}

	return 0;
}

struct struct_patt
{
	int mesu1;
	int mesu2;
	int mesure;
	int canal[16];
}
patt[40];

int pattern1 ( n, c, p )
int n;
int c;
unsigned char * p;
{
	int i;
	char zeros[16];

	memset ( zeros, 0, sizeof ( zeros ) );
	if ( memcmp ( p + 1, zeros, sizeof ( zeros ) ) != 0 )
	{
		printf ( "User-%d%c: ", n, c );
		for ( i = 0; i < 16; i++ )
		{
			if ( p [ 1 + i ] & 0x80 )
				printf ( ">%2d", p [ 1 + i ] & 0x7f );
			else
				printf ( " %2d", p [ 1 + i ] );
		}
		printf ( "   %d\n", p [ 0 ] + 1 );

	}
	xx ( "User-..", p + 16, 4 );

	return 0;
}

int pattern ( buf )
unsigned char * buf;
{
	int i;
	int u;
	int a;
	int p;
	int np;

	printf (
		"  CANAL:  01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 TEMPS\n" );
	p = 0;

	for ( u = 1; u <= 8; u++ )
	{
		for ( a = 0; a < 4; a++ )
		{
			np = (u-1) * 4 + a;
			patt[np].mesu1 = buf [ p + 16+1 ] + 256 * (int) buf [ p + 16+2 ];
			patt[np].mesu2 = patt[np].mesu1 + buf [ p + 16+3 ];
			for ( i = 0; i < 16; i++ )
				patt[np].canal[i] = buf [ p + 1 + i ] & 0x7f;
			patt[np].mesure = buf [ p ] + 1;
			pattern1 ( u, 'A' + a, buf + p );
			p += 16 + 5;
		}
	}

	for ( u = 1; u <= 8; u++ )
	{
		np = 32 + (u-1);
		patt[np].mesu1 = buf [ p + 16+1 ] + 256 * (int) buf [ p + 16+2 ];
		patt[np].mesu2 = patt[np].mesu1 + buf [ p + 16+3 ];
		for ( i = 0; i < 16; i++ )
			patt[np].canal[i] = buf [ p + 1 + i ] & 0x7f;
		patt[np].mesure = buf [ p ] + 1;
		pattern1 ( u, 'F', buf + p );
		p += 16 + 5;
	}

	return 0;
}

int mesur1 ( u, a, n, pt )
int u;
int a;
int n;
unsigned char * pt;
{
	int i;
	unsigned char c;

	if ( pt[0] != 0xff )
	{
		printf ( "\nUser-%d%c.%d:", u, a, n );
		for ( i = 0; ( c = pt [ i ] ) != 0xff; i++ )
		{
			if ( c & 0x80 )
			{
				if ( ( c & 0x7f ) % 24 == 0 )
					printf ( "   %d.", ( c & 0x7f ) / 24 + 1 );
				else
					printf ( " %d.%02d", ( c & 0x7f ) / 24 + 1, ( c & 0x7f ) % 24 );
			}
			else
			{
				printf ( " %02d/%d", (c%16)+1, c / 16 );
			}
			if ( i % 12 == 11 )
				printf ( "\n          " );
		}
		printf ( "\n" );
	}

	return 0;
}

int mesur ( buf )
unsigned char * buf;
{
	int u;
	int a;
	int np;

	for ( u = 1; u <= 8; u++ )
	{
		for ( a = 0; a < 4; a++ )
		{
			np = (u-1) * 4 + a;
			mesur1 ( u, 'A' + a, 1, buf + patt[np].mesu1 );
			mesur1 ( u, 'A' + a, 2, buf + patt[np].mesu2 );
		}
	}

	for ( u = 1; u <= 8; u++ )
	{
		np = 32 + (u-1);
		mesur1 ( u, 'F', 1, buf + patt[np].mesu1 );
		mesur1 ( u, 'F', 2, buf + patt[np].mesu2 );
	}
	
	return 0;
}

int tab_perc[128] =
{
/* LK note numero 39 -> 84, perc numero 0 -> 42 */
/* 00 */ 60, 62, 57, 59, 55, 53, 48, 52, 49, 51,
/* 10 */ 58, 56, 54, 46, 44, 42, 45, 82, 83, 81,
/* 20 */ 80, 78, 47, 79, 77, 76, 74, 72, 71, 70,
/* 30 */ 75, 73, 61, 64, 43, 67, 69, 66, 68, 84,
/* 40 */ 39, 63, 65,
/* UK note numero 86 -> 124, perc numero 43 -> 75 */
/* 40 */             86, 88, 93, 89, 39,105,110,	/* [47]=?? */
/* 50 */ 98, 99,101,121,123,115,119,117,113,108,
/* 60 */ 94, 92, 90, 87,112,103,107,100,118,120,
/* 70 */124,122, 97, 95, 96, 91,
};

int outpat1 ( f, n, pt, mes, pi )
FILE * f;
int n;
unsigned char * pt;
int mes;
int pi;
{
	unsigned char *p;
	int tps, t24;
	int noteon[16];
	int canal;

	if ( pi == 1 )
		p = pt + patt[n].mesu1;
	else
		p = pt + patt[n].mesu2;

	fprintf ( f, "%03d.1.00.000 --- %s %d\n",
		mes, mot[18], patt[n].mesure );

	for ( canal = 0; canal < 16; canal++ )
		noteon[canal] = 0;

	while ( *p != 0xff )
	{
		if ( *p & 0x80 )
		{
			tps = ( *p & 0x7f ) / 24 + 1;
			t24 = ( *p & 0x7f ) % 24;
		}
		else
		{
			canal = *p & 0x0f;
			noteon[canal]++;
			fprintf ( f, "%03d.%d.%02d.000 C15 %s  %3d %3d\n",
				mes, tps, t24, mot[10],
				tab_perc[ patt[n].canal[canal] ],
				15 + 16 * ( *p / 16 )
				);
		}
		p++;
	}
	for ( canal = 0; canal < 16; canal++ )
	{
		if ( noteon[canal] )
			fprintf ( f, "%03d.%d.23.005 C15 %s %3d %3d\n",
				mes, patt[n].mesure, mot[14],
				tab_perc[ patt[n].canal[canal] ],
				0
				);
	}

	return 0;
}

outpat ( pt )
unsigned char * pt;
{
	char nom[40];
	FILE * f;
	int i,j,n;

	sprintf ( nom, "%s.pat", fichier );
	printf ( "\nEXTRACTION des patterns -> fichier '%s'\n", nom );

	f = fopen ( nom, "w" );
	if ( f == NULL )
	{
		perror ( nom );
		return 1;
	}

	fprintf ( f, "\tPATTERNS DE %s\n", fichier );

	for ( i = 0; i < 8; i++ )
	{
		for ( j = 0; j < 4; j++ )
		{
			n = i*4 + j;
			fprintf ( f, "\trythme %03d.1  %s\n", n+67, rythme ( n+67 ) );
			outpat1 ( f, n, pt, 1, 1 );
			fprintf ( f, "\trythme %03d.2  %s\n", n+67, rythme ( n+67 ) );
			outpat1 ( f, n, pt, 2, 2 );
		}
		n = 32 + i;
		fprintf ( f, "\trythme %03d.1F %s\n", n+67, rythme ( n+67 ) );
		outpat1 ( f, n, pt, 1, 1 );
		fprintf ( f, "\trythme %03d.2F %s\n", n+67, rythme ( n+67 ) );
		outpat1 ( f, n, pt, 2, 2 );
	}

	fprintf ( f, "\tFIN DES PATTERNS DE %s\n", fichier );
	fclose ( f );
	return 0;
}

int outpre ( f, n, c, mes, pi )
FILE *f;
int n;
int c;
int mes;
int pi;
{
	FILE * p;
	char ligne[120];
	char mot[40];
	int num;
	int m;
	char code;

	p = fopen ( "pattern.dat", "r" );
	if ( p == NULL )
	{
		perror ( "pattern.dat" );
		return 1;
	}

	while ( fgets ( ligne, sizeof(ligne), p ) != NULL )
	{
		if ( ( ligne[0] > 0 ) && ( ligne[0] <= ' ' ) )
			if ( sscanf ( ligne, "%s %d.%d%c", mot, &num, &m, &code ) == 4 )
				if ( ( num == n ) && ( m == pi ) && ( code == c ) )
				{
					while ( fgets ( ligne, sizeof(ligne), p ) != NULL )
					{
						if ( ( ligne[0] >= '0' ) && ( ligne[0] <= '9' ) )
							fprintf ( f, "%03d%s", mes, ligne+3 );
						else
							break;
					}
					fclose ( p );
					return 0;
				}
	}

	printf ( "Rythme numero %d, mesure %d%c ???\n", n, pi, c );
	fclose ( p );

	return 0;
}

int outseq ( n, pt )
int n;
unsigned char * pt;
{
	char nom[40];
	int mes;
	int pi;
	int i;
	FILE * f;
	int norythme;
	int fill;

	if ( tabseq[n][0].t == 0 )
		return 0;

	sprintf ( nom, "%s.sq%d", fichier, n+1 );
	printf ( "\nEXTRACTION de la sequence %d -> fichier '%s'\n", n+1, nom );

	f = fopen ( nom, "w" );
	if ( f == NULL )
	{
		perror ( nom );
		return 1;
	}
	fprintf ( f, "\tSEQUENCE %d DE %s\n", n+1, fichier );
	mes = 1;
	fill = 0;
	pi = 1;
	for ( i = 0; i < 120; i++ )
	{
		if ( tabseq[n][i].t == 0 )
			break;

		norythme = tabseq[n][i].n;

		if ( fill == 1 )
		{
			if ( ( tabseq[n][i].t & 0x04 ) == 0 )
			{
				pi = 1;
				fill = 0;
			}
		}
		else
		{
			if ( ( tabseq[n][i].t & 0x04 ) != 0 )
			{
				pi = 1;
				fill = 1;
			}
		}

		fprintf ( f, "\trythme %03d.%d%c %s\n",
			norythme,
			pi,
			tabseq[n][i].t & 0x04 ? 'F' : ' ',
			rythme ( norythme ) );

		switch ( tabseq[n][i].t )
		{
			case 1:	/* USER */
			case 5:	/* USER + FILL */
				outpat1 ( f, norythme - 67, pt, mes, pi );
				break;

			case 2:	/* PRESET */
				outpre ( f, norythme, ' ', mes, pi );
				break;

			case 6:	/* PRESET+FILL */
				outpre ( f, norythme, 'F', mes, pi );
				break;
		}
		mes++;
		if ( pi == 1 )
			pi = 2;
		else
			pi = 1;
	}
	fprintf ( f, "\tFIN DE LA SEQUENCE %d DE %s\n", n+1, fichier );
	fprintf ( f, "%03d.1.00.000 --- %s\n\n", mes, mot[16] );
	fclose ( f );

	return 0;
}


