/*
	File: REG.C

	Dumping of a registration
*/

#include <stdio.h>

#include "b00.h"

int clavi ( nom, pt, pts, nbsect )
int nom;
unsigned char * pt;
unsigned char * pts;
int nbsect;
{
	int i;

	xx ( clavier(nom), pt, nom < 5 ? ( nom == 0 ? 7 : 6 ) : 5 );

	if ( ( volume ( pt[1] & 0x7f ) != 0 ) || ( opt & OPT_ALL ) )
	{
		printf ( "%-4s: %-16.16s volume=%2d%s%s%s%s%s%s\n",
			clavier(nom),
			instrument ( pts[ pt[0] & 0x0f ] ), 
			volume ( pt[1] & 0x7f ),
			feet ( pt[2] & 0x3 ),
			effet ( ( pt[2] >> 2 ) & 0x7 ),
			tone ( pt[4] & 0x7 ),
			pt[3] & 0x80 ?
				(	nom >= 5
						? uvib ( pt[3] & 0x7, 0, 0 )
						: uvib ( pt[5] & 0x7,
							( pt[5] >> 3 ) & 0x07,
							pt[3] & 0x7 )
				)
				: "",
			pt[0] & 0x80 ? " T-VIB" : "",
			pt[3] & 0x40 ? " TO-LOWER" : ""
			);
	}

	if ( opt & OPT_SECT )
	{
		xx ( "SECTION", pts, nbsect );
		printf ( "SECTIONS %s: selection=%d\n", clavier(nom), pt[0] & 0x0f );
		for ( i = 0; i < nbsect; i++ )
		{
			if ( ( i>0 ) && ( i % 4 == 0 ) )
				printf ( "\n" );
			printf ( " %2d=%-14.14s", i, instrument ( pts[ i ] ) );
		}
		printf ( "\n" );
	}

	return 0;
}

bloc_reg1 ( bloc )
unsigned char * bloc;
{
	int i;

	clavi ( CLAV_LEAD, bloc + REG_LEAD, bloc + SECTIONS_LEAD, 5 );
	clavi ( CLAV_UK1,  bloc + REG_UK1,  bloc + SECTIONS_UK1, 14 );
	clavi ( CLAV_UK2,  bloc + REG_UK2,  bloc + SECTIONS_UK2, 14 );
	clavi ( CLAV_LK1,  bloc + REG_LK1,  bloc + SECTIONS_LK1, 14 );
	clavi ( CLAV_LK2,  bloc + REG_LK2,  bloc + SECTIONS_LK2, 14 );
	clavi ( CLAV_PED1, bloc + REG_PED1, bloc + SECTIONS_PED1, 5 );
	clavi ( CLAV_PED2, bloc + REG_PED2, bloc + SECTIONS_PED2, 5 );

	xx ( "RYTHME", bloc+REG_RYTHME, 8 );

	if ( bloc [ REG_RYTHME ] & 0xc0 )
		printf ( "PERCUSION:%s%s\n",
			bloc [ REG_RYTHME ] & 0x40 ? " LOWER" : "",
			bloc [ REG_RYTHME ] & 0x80 ? " PEDAL" : "" );

	if ( bloc [ REG_RYTHME + 7 ] & 0x03 )
		printf ( "MEMORY:%s%s\n",
			bloc [ REG_RYTHME + 7 ] & 0x01 ? " LOWER" : "",
			bloc [ REG_RYTHME + 7 ] & 0x02 ? " PEDAL" : "" );

	if ( ( volume ( bloc [ REG_RYTHME + 1 ] & 0x7f ) != 0 )
	  || ( volume ( bloc [ REG_RYTHME + 2 ] & 0x7f ) != 0 )
	  || ( opt & OPT_ALL ) )
	{
		printf ( "RYTHME: %s volume=%2d tempo=%d%s\n",
			rythme ( bloc [ SECTIONS_RYTHME + ( bloc [ REG_RYTHME ] & 0x0f ) ] ),
			volume ( bloc [ REG_RYTHME + 1 ] & 0x7f ),
			( int ) bloc [ REG_RYTHME + 5 ] + 40,
			bloc [ REG_RYTHME + 2 ] & 0x80 ? " AUTO.VAR" : "" );

		if ( ( volume ( bloc [ REG_RYTHME + 2 ] & 0x7f ) != 0 )
		  || ( opt & OPT_ALL ) )
		{
			printf ( "ACCOMP: type=%d  volume=%d%s%s%s%s\n",
				( ( bloc [ REG_RYTHME + 4 ] >> 4 ) & 0x03 ) + 1,
				volume ( bloc [ REG_RYTHME + 2 ] & 0x7f ),
				( bloc [ REG_RYTHME + 7 ] & 0x0c ) == 0x04 ? " Single" :
				( bloc [ REG_RYTHME + 7 ] & 0x0c ) == 0x08 ? " Fingered" :
				( bloc [ REG_RYTHME + 7 ] & 0x0c ) == 0x0c ? " Custom" : "",
				( bloc [ REG_RYTHME + 7 ] & 0x30 ) == 0x10 ? " MOC1" :
				( bloc [ REG_RYTHME + 7 ] & 0x30 ) == 0x20 ? " MOC2" :
				( bloc [ REG_RYTHME + 7 ] & 0x30 ) == 0x30 ? " MOC3" : "",
				bloc [ REG_RYTHME + 6 ] & 0x80 ? " Solostyle" : "",
				bloc [ REG_RYTHME + 7 ] & 0x80 ? " KNEE" : ""
				);
		}
	}

	if ( opt & OPT_SECT )
	{
		xx ( "SECTION", bloc+SECTIONS_RYTHME, 12 );
		printf ( "SECTIONS RYTHME: selection=%d\n", bloc [ REG_RYTHME ] & 0x0f );
		for ( i = 0; i < 12; i++ )
		{
			if ( ( i>0 ) && ( i % 4 == 0 ) )
				printf ( "\n" );
			printf ( " %2d=%-14.14s", i, rythme ( bloc [ SECTIONS_RYTHME + i ] ) );
		}
		printf ( "\n" );
	}

	xx ( "SUSTAIN", bloc + REG_SUSTAIN, 3 );

	if ( ( bloc [ REG_SUSTAIN ] & 0xe0 ) || ( opt & OPT_ALL ) )
	{
		printf ( "SUSTAIN:" );
		if ( bloc [ REG_SUSTAIN ] & 0x80 )
			printf ( " UPPER=%d", bloc [ REG_SUSTAIN ] & 0x0f );
		else if ( opt & OPT_ALL )
			printf ( " UPPER=OFF(%d)", bloc [ REG_SUSTAIN ] & 0x0f );
		if ( bloc [ REG_SUSTAIN ] & 0x40 )
			printf ( " LOWER=%d", bloc [ REG_SUSTAIN + 1 ] & 0x0f );
		else if ( opt & OPT_ALL )
			printf ( " LOWER=OFF(%d)", bloc [ REG_SUSTAIN + 1 ] & 0x0f );
		if ( bloc [ REG_SUSTAIN ] & 0x20 )
			printf ( " PEDAL=%d", bloc [ REG_SUSTAIN + 1 ] >> 4 );
		else if ( opt & OPT_ALL )
			printf ( " PEDAL=OFF(%d)", bloc [ REG_SUSTAIN + 1 ] >> 4 );
		printf ( "\n" );
	}

	xx ( "FOOT.SW", bloc + REG_FOOTSW, 3 );

	if ( ( bloc [ REG_FOOTSW ] & 0x07 ) || ( opt & OPT_ALL ) )
	{
		printf ( "FOOT.SW: " );
		if ( ( bloc [ REG_FOOTSW ] & 0x07 ) == 0x00 )
			printf ( " OFF" );
		else if ( ( bloc [ REG_FOOTSW ] & 0x07 ) == 0x01 )
			printf ( " rythme %s",
				( ( bloc [ REG_FOOTSW ] >> 3 ) & 0x03 ) == 0x01 ? "stop" :
				( ( bloc [ REG_FOOTSW ] >> 3 ) & 0x03 ) == 0x02 ? "end" :
				( ( bloc [ REG_FOOTSW ] >> 3 ) & 0x03 ) == 0x03 ? "fill" :
				"?0?");
		else if ( ( bloc [ REG_FOOTSW ] & 0x07 ) == 0x02 )
			printf ( " glide%s%s%s",
				bloc [ REG_FOOTSW + 1 ] & 0x10 ? " LEAD" : "",
				bloc [ REG_FOOTSW + 1 ] & 0x01 ? " UPPER" : "",
				bloc [ REG_FOOTSW + 1 ] & 0x04 ? " LOWER" : ""
				);
		else if ( ( bloc [ REG_FOOTSW ] & 0x07 ) == 0x03 )
			printf ( " tremolo" );
		else
			printf ( " ?%d?",
				bloc [ REG_FOOTSW ] & 0x07 );
		printf ( "\n" );
	}

	xx ( "REVERB", bloc + REG_REVERB, 1 );

	printf ( "REVERB: %d\n",
		volume ( bloc [ REG_REVERB ] & 0x7f ) );

	xx ( "TREMOLO", bloc + REG_TREM_FAST, 1 );

	if ( bloc [ REG_TREM_FAST ] & 0x80 )
		printf ( "TREMOLO: FAST\n" );

	yy ( "YY2", bloc + REG_YY2, 24 );

	if ( ( bloc [ REG_UPFLUTE ] & 0x40 ) || ( opt & OPT_ALL ) )
		flute ( "UPPER FLUTE", bloc + REG_UPFLUTE );

	if ( ( bloc [ REG_LWFLUTE ] & 0x40 ) || ( opt & OPT_ALL ) )
		flute ( "LOWER FLUTE", bloc + REG_LWFLUTE );

	yy ( "YY3", bloc + REG_YY3, 23 );

	return 0;
}

int regseq ( pt )
unsigned char * pt;
{
	int i;

	yy ( "YY4", pt, 3 );

	if ( pt[3] != 0xff )
	{
		printf ( "\nREG.SEQUENCE: " );
		for ( i = 0; i < 80; i++ )
		{
			if ( pt[i+3] == 0xff )
				break;
			else
				printf ( "%3d", pt[i+3] + 1 );
			if ( i % 16 == 15 )
				printf ( "\n              " );
		}
		printf ( "\n" );
	}

	yy ( "YY5", pt + 83, 1 );

	return 0;
}

