#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mevt.h>

static FILE *mf_f = NULL;
static char mf_nom[100];


mf_exit ( int ex )
{
    getchar();
    exit(ex);
}


int mf_w_open ( char * nom )
{
    if ( mf_f != NULL )
        fclose ( mf_f );
    
    mf_f = fopen ( nom, "w+b");
    strcpy ( mf_nom, nom );
    
    if ( mf_f == NULL )
    {
        perror ( nom );
        mf_exit(1);
    }
    return 0;
}


int mf_close ()
{
    if ( mf_f != NULL )
        fclose ( mf_f );
    
    mf_f = NULL;
    return 0;
}


int mf_write ( BYTE * pt, int lg )
{
    int nb;
    
    nb = fwrite ( pt, 1, lg, mf_f );
    if ( nb != lg )
    {
        perror( "write" );
        mf_exit(1);
    }
    return 0;
}

int mf_write_B ( BYTE x )
{
    mf_write ( &x, 1 );
    return 0;
}

int mf_write_W ( WORD x )
{
	BYTE w[2];

	w[0] = ( x >> 8 ) &0xFF;
	w[1] = x & 0xFF;
    mf_write ( &w, 2 );
    
    return 0;
}

int mf_write_3 ( LONG x )
{
	BYTE w3[3];

	w3[0] = ( x >> 16 ) & 0xFF;
	w3[1] = ( x >> 8 ) & 0xFF;
	w3[2] = x & 0xFF;
    mf_write ( &w3, 3 );
    
    return 0;
}

int mf_write_L ( LONG x )
{
	BYTE l[3];

	l[0] = ( x >> 24 ) & 0xFF;
	l[1] = ( x >> 16 ) & 0xFF;
	l[2] = ( x >> 8 ) & 0xFF;
	l[3] = x & 0xFF;
    mf_write ( &l, 4 );
    
    return 0;
}

int mf_write_S ( char *x )
{
    mf_write ( (BYTE *)x, strlen(x) );
    
    return 0;
}

int mf_set ( long p )
{
    if ( fseek ( mf_f, p, SEEK_SET )!= 0 )
    {
        perror ( "fseek" );
        mf_exit(1);
    }

    return 0;
}

long mf_pos ( )
{
    long pos;
    
    pos = ftell ( mf_f );
    
    if ( pos == -1L )
    {
        perror ( "ftell" );
        mf_exit(1);
    }

    return pos;
}

